<?php
// $Id: subdomains.php
// Author: Brian N. Smith
// Copyright (c) 2014 Michael Stauber, SOLARSPEED.NET
// Copyright (c) 2014 Team BlueOnyx, BLUEONYX.IT
// Copyright (c) 2006 NuOnce Networks, Inc.
// All Rights Reserved.

include_once('UIExtension.php');
class subdomainsExtension extends UIExtension
{
    function display(&$ServerScriptHelper, &$container, $parameters) {
        $cce = $ServerScriptHelper->getCceClient();

        if ( isset($parameters["VSITE_OID"]) ) {
            $feature = $cce->get($parameters["VSITE_OID"], "subdomains");
            if ( !$feature["vsite_enabled"] ) {
                return;
            }
        }

        $defaults = $cce->get($parameters["CCE_OID"], "subdomains");
        $factory = $ServerScriptHelper->getHtmlComponentFactory("base-subdomains");

        $i18n = $ServerScriptHelper->getI18n();

        // At this time we don't want an extra tab for Subdomains. Or we would use
        // this code here instead:
        //$pageId = $i18n->getHtml("subdomain_header", "base-subdomains");
        //$container->addPage($pageId, $factory->getLabel("subdomain_header"));

        $pageId = "account";

        $container->addFormField(
            $factory->getBoolean("subEnabled", $defaults["enabled"]),
            $factory->getLabel("enabled"), 
            $pageId);

        $user = $cce->get($parameters["CCE_OID"]);
        $site = $cce->getObject('Vsite', array('name' => $user["site"]));
    }


    function handle(&$helper, &$errors, &$cce_info, &$attributes) {

        $this->attributes = $attributes;

        $cce = $helper->getCceClient();

        if (!isset($this->attributes['subEnabled'])) {
            $subEnabled = '0';
        }
        else {
            $subEnabled = $this->attributes['subEnabled'];
        }

        $cce->set($cce_info["CCE_OID"], 'subdomains', array('enabled' => $subEnabled));

        $errors = array_merge($errors, $cce->errors());
    } 
}
?>
